> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pyx.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# GPU support

The pyx GPU indexes consist of curated, pre-built wheels for PyTorch,
[vLLM](https://github.com/vllm-project/vllm),
[DeepSpeed](https://github.com/deepspeedai/DeepSpeed),
[Flash Attention](https://github.com/Dao-AILab/flash-attention),
[SageAttention](https://github.com/thu-ml/SageAttention), and other
hardware-accelerated libraries.

pyx includes a dedicated Simple API-compatible index for every supported CUDA
version:

* [https://api.pyx.dev/simple/astral-sh/cu118](https://api.pyx.dev/simple/astral-sh/cu118)
  (CUDA 11.8)
* [https://api.pyx.dev/simple/astral-sh/cu121](https://api.pyx.dev/simple/astral-sh/cu121)
  (CUDA 12.1)
* [https://api.pyx.dev/simple/astral-sh/cu124](https://api.pyx.dev/simple/astral-sh/cu124)
  (CUDA 12.4)
* [https://api.pyx.dev/simple/astral-sh/cu126](https://api.pyx.dev/simple/astral-sh/cu126)
  (CUDA 12.6)
* [https://api.pyx.dev/simple/astral-sh/cu128](https://api.pyx.dev/simple/astral-sh/cu128)
  (CUDA 12.8)
* [https://api.pyx.dev/simple/astral-sh/cu129](https://api.pyx.dev/simple/astral-sh/cu129)
  (CUDA 12.9)
* [https://api.pyx.dev/simple/astral-sh/cu130](https://api.pyx.dev/simple/astral-sh/cu130)
  (CUDA 13.0)

Once authenticated, you can install, e.g., PyTorch, vLLM, and Flash Attention
from the pyx GPU indexes with:

```shell theme={null}
# Use the CUDA 12.6 index.
uv pip install torch flash-attn vllm --torch-backend cu126

# Infer the latest compatible CUDA version based on your GPU.
uv pip install torch flash-attn vllm --torch-backend auto
```

Alternatively, you can specify an index URL directly:

```shell theme={null}
uv pip install torch flash-attn vllm --index https://api.pyx.dev/simple/astral-sh/cu126
```

Or, configure the index in your `pyproject.toml`:

```toml pyproject.toml icon="square-code" theme={null}
[[tool.uv.index]]
name = "cu126"
url = "https://api.pyx.dev/simple/astral-sh/cu126"
```

At present, the GPU indexes include builds for the following packages:

* PyTorch (mirrored directly from the
  [PyTorch index](https://download.pytorch.org))
* [vLLM](https://github.com/vllm-project/vllm)
* [Flash Attention](https://github.com/Dao-AILab/flash-attention)
* [Flash Attention 3](https://github.com/Dao-AILab/flash-attention)
* [SageAttention2++](https://github.com/thu-ml/SageAttention)
* [SageAttention3](https://github.com/thu-ml/SageAttention)
* [FlashInfer](https://github.com/flashinfer-ai/flashinfer)
* [DeepSpeed](https://github.com/deepspeedai/DeepSpeed)
* [DeepGEMM](https://github.com/deepseek-ai/DeepGEMM)
* [DeepEP](https://github.com/deepseek-ai/DeepEP)
* [MegaBlocks](https://github.com/databricks/megablocks)
* [Grouped GEMM](https://github.com/tgale96/grouped_gemm)
* [NATTEN](https://github.com/SHI-Labs/NATTEN)
* [PyTorch Scatter](https://github.com/rusty1s/pytorch_scatter)
* [PyTorch Cluster](https://github.com/rusty1s/pytorch_cluster)
* [PyTorch Sparse](https://github.com/rusty1s/pytorch_sparse)
* [torch-spline-conv](https://github.com/rusty1s/pytorch_spline_conv)
* [pyg-lib](https://github.com/pyg-team/pyg-lib)
* [Mamba SSM](https://github.com/state-spaces/mamba)
* [causal-conv1d](https://github.com/Dao-AILab/causal-conv1d)
* [Apex](https://github.com/NVIDIA/apex)
* [TransformerEngine](https://github.com/NVIDIA/TransformerEngine)
* [PyTorch3D](https://github.com/facebookresearch/pytorch3d)
* [Detectron2](https://github.com/facebookresearch/detectron2)
* [MMCV](https://github.com/open-mmlab/mmcv)
* [Adan](https://github.com/sail-sg/Adan)
* [PyCUDA](https://github.com/inducer/pycuda)
* [nvMolKit](https://github.com/NVIDIA-Digital-Bio/nvMolKit)

Packages in the GPU index are typically built for Python 3.9 to Python 3.14,
CUDA 12.4 to CUDA 13.0, and both x86\_64 and ARM64 architectures (barring
exceptions for packages with more limited Python or CUDA support).

(Missing something? [Let us know](/contact).)

Every wheel in the index is built against a specific version of PyTorch and
CUDA, then modified to make the metadata available to the dependency resolver.
As such, installing from, e.g., `https://api.pyx.dev/simple/astral-sh/cu126`
ensures that uv installs consistent, compatible versions of PyTorch, CUDA, and
the other GPU-accelerated dependencies.

You can browse the pyx GPU indexes in the [pyx dashboard](https://app.pyx.dev),
or by querying the Simple API:

```shell theme={null}
export PYX_TOKEN=$(uv auth token pyx.dev)
curl https://api.pyx.dev/simple/astral-sh/cu126 --header "Authorization: Bearer $PYX_TOKEN"
```

You can also visit the Simple API URLs directly in your browser after logging in
to the [pyx dashboard](https://app.pyx.dev).

## Jetson mirrors

pyx provides mirrors of the [Jetson AI Lab](https://www.jetson-ai-lab.com/)
package indexes for NVIDIA Jetson devices. These indexes can be enabled upon
request by [contacting us](/contact).

Once enabled, the following indexes are available:

* [https://api.pyx.dev/simple/jetson-ai-lab/jp6-cu126](https://api.pyx.dev/simple/jetson-ai-lab/jp6-cu126)
  (JetPack 6, CUDA 12.6)
* [https://api.pyx.dev/simple/jetson-ai-lab/jp6-cu128](https://api.pyx.dev/simple/jetson-ai-lab/jp6-cu128)
  (JetPack 6, CUDA 12.8)
* [https://api.pyx.dev/simple/jetson-ai-lab/jp6-cu129](https://api.pyx.dev/simple/jetson-ai-lab/jp6-cu129)
  (JetPack 6, CUDA 12.9)
* [https://api.pyx.dev/simple/jetson-ai-lab/sbsa-cu130](https://api.pyx.dev/simple/jetson-ai-lab/sbsa-cu130)
  (SBSA, CUDA 13.0)
